// SntxAddn.cpp : Implementation of DLL Exports.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/05/18 06:10:09
//

// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f SntxAddnps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "SntxAddn.h"

#include "SntxAddn_i.c"
#include "WordSntxAddn.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_WordSntxAddn, CWordSntxAddn)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////

class CWordSntxAddnApp : public CWinApp
{
public:
    BOOL InitInstance()
	{
		_Module.Init(ObjectMap, m_hInstance, &LIBID_SNTXADDNLib);
		return CWinApp::InitInstance();
	};

    int ExitInstance()
	{
		_Module.Term();
		return CWinApp::ExitInstance();
	}

public:
	static VOID RemoveCommandBar();

protected:
	static CComPtr <_Application> AttachRunningWord();

};

CWordSntxAddnApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	// remove registry
	HRESULT hr = _Module.UnregisterServer(TRUE);

	// remove commmand bar
	CWordSntxAddnApp::RemoveCommandBar();

	// return result
    return hr;
}

//
// String in resource
//
LPCTSTR RSTR(UINT nID)
{
	static TCHAR sz[1024];

	if( LoadString(_Module.GetResourceInstance(), nID, sz, 1024) )
		return sz;
	else
		return _T("");
}

//
// Attach or Create Word Application instance
//
CComPtr <_Application> CWordSntxAddnApp::AttachRunningWord()
{
	HRESULT hr;
	CLSID   clsid;

	hr = ::CLSIDFromProgID(L"Word.Application", &clsid);
	if(FAILED(hr))
	{
		return NULL;
	}

	IUnknown  * pUnknown = NULL;

	hr = ::GetActiveObject(clsid, NULL, &pUnknown);
	if( !FAILED(hr) )
	{
		return CComQIPtr <_Application> ( pUnknown );
	}
	else
	{
		COleDispatchDriver ddrv;

		ddrv.CreateDispatch(clsid);

		return CComQIPtr <_Application> (ddrv.m_lpDispatch);
	}
}

//
// Call remove command bar and quit word
//
VOID CWordSntxAddnApp::RemoveCommandBar()
{
	// attach
	CComPtr <_Application> wordApp = AttachRunningWord();

	if( wordApp == NULL )
		return;

	// remove
	CWordSntxAddn::RemoveCommandBar( wordApp );

	// close
	if( wordApp->GetWindows()->GetCount() == 0 )
	{
		wordApp->Quit();
	}
}
