// SyntaxModule.cpp: implementation of the CSyntaxModule class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/05/17 01:21:11
//

#include "stdafx.h"
#include "sntxaddn.h"
#include "SyntaxModule.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////

CSyntaxModule::CSyntaxModule()
{
	m_hInstSyntax    = NULL;

	m_lpfnGetCaption = NULL;
	m_lpfnGetTooltip = NULL;
	m_lpfnGetBtnFace = NULL;
	m_lpfnParse      = NULL;
	m_lpfnGetNextPos = NULL;
	m_lpfnGetColor   = NULL;
	m_lpfnGetBgColor = NULL;

	m_bAttached      = FALSE;
}

CSyntaxModule::~CSyntaxModule()
{
	if( m_hInstSyntax != NULL )
		FreeLibrary(m_hInstSyntax);
}

CSyntaxModule * CSyntaxModule::LoadSyntaxModule(LPCTSTR szDllPath)
{
	// Load
	HINSTANCE hInstSyntax = LoadLibrary(szDllPath);

	if( hInstSyntax == NULL )
		return NULL;

	FN_GetCaption lpfnGetCaption = (FN_GetCaption)GetProcAddress(hInstSyntax, "GetCaption");
	FN_GetTooltip lpfnGetTooltip = (FN_GetTooltip)GetProcAddress(hInstSyntax, "GetTooltip");
	FN_GetBtnFace lpfnGetBtnFace = (FN_GetBtnFace)GetProcAddress(hInstSyntax, "GetBtnFace");
	FN_Parse      lpfnParse      = (FN_Parse     )GetProcAddress(hInstSyntax, "Parse"     );
	FN_GetNextPos lpfnGetNextPos = (FN_GetNextPos)GetProcAddress(hInstSyntax, "GetNextPos");
	FN_GetColor   lpfnGetColor   = (FN_GetColor  )GetProcAddress(hInstSyntax, "GetColor"  );
	FN_GetBgColor lpfnGetBgColor = (FN_GetBgColor)GetProcAddress(hInstSyntax, "GetBgColor");

	if( lpfnGetCaption == NULL ||
		lpfnParse      == NULL ||
		lpfnGetNextPos == NULL ||
		lpfnGetColor   == NULL )
	{
		FreeLibrary(hInstSyntax);
		return NULL;
	}

	// Create
	CSyntaxModule * pSyntax   = new CSyntaxModule();

	pSyntax->m_hInstSyntax    = hInstSyntax;

	pSyntax->m_lpfnGetCaption = lpfnGetCaption;
	pSyntax->m_lpfnGetTooltip = lpfnGetTooltip;
	pSyntax->m_lpfnGetBtnFace = lpfnGetBtnFace;
	pSyntax->m_lpfnParse      = lpfnParse     ;
	pSyntax->m_lpfnGetNextPos = lpfnGetNextPos;
	pSyntax->m_lpfnGetColor   = lpfnGetColor  ;
	pSyntax->m_lpfnGetBgColor = lpfnGetBgColor;

	return pSyntax;
}
