// SyntaxModule.h: interface for the CSyntaxModule class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/05/17 01:21:11
//

#ifndef AFX_SYNTAXMODULE_H__
#define AFX_SYNTAXMODULE_H__

// fn type
typedef LPCSTR (*FN_GetCaption)();
typedef LPCSTR (*FN_GetTooltip)();
typedef HBITMAP(*FN_GetBtnFace)();
typedef VOID   (*FN_Parse     )(LPWSTR text, INT len);
typedef BOOL   (*FN_GetNextPos)(INT & pos, INT & len);
typedef BOOL   (*FN_GetColor  )(INT & color  );
typedef BOOL   (*FN_GetBgColor)(INT & bgcolor);

class CSyntaxModule
{
public:
	virtual ~CSyntaxModule();

	// Required
	inline LPCSTR GetCaption() { return (*m_lpfnGetCaption)(); }
	inline VOID   Parse     (LPWSTR text, INT len) {        (*m_lpfnParse     )(text, len); }
	inline BOOL   GetNextPos(INT & pos, INT & len) { return (*m_lpfnGetNextPos)(pos , len); }
	inline BOOL   GetColor  (INT & color  )        { return (*m_lpfnGetColor  )(color    ); }

	// Optional
	inline LPCSTR  GetTooltip()              { return m_lpfnGetTooltip ? (*m_lpfnGetTooltip)()          : ""    ; }
	inline HBITMAP GetBtnFace()              { return m_lpfnGetBtnFace ? (*m_lpfnGetBtnFace)()          : NULL  ; }
	inline BOOL    GetBgColor(INT & bgcolor) { return m_lpfnGetBgColor ? (*m_lpfnGetBgColor)(bgcolor  ) : FALSE ; }

public:
	static CSyntaxModule * LoadSyntaxModule(LPCTSTR szDllPath);

public:
	CString m_szSyntaxName;
	BOOL    m_bAttached;

protected:
	CSyntaxModule(); // can be created by static 'LoadSyntaxModule' only

	HINSTANCE     m_hInstSyntax;

	FN_GetCaption m_lpfnGetCaption;
	FN_GetTooltip m_lpfnGetTooltip;
	FN_GetBtnFace m_lpfnGetBtnFace;
	FN_Parse      m_lpfnParse;
	FN_GetNextPos m_lpfnGetNextPos;
	FN_GetColor   m_lpfnGetColor;
	FN_GetBgColor m_lpfnGetBgColor;

};

#endif//AFX_SYNTAXMODULE_H__
